diff --git a/src/backend/optimizer/path/clausesel.c b/src/backend/optimizer/path/clausesel.c
index bb148d7..cae5562 100644
--- a/src/backend/optimizer/path/clausesel.c
+++ b/src/backend/optimizer/path/clausesel.c
@@ -13,17 +13,29 @@
  *-------------------------------------------------------------------------
  */
 #include "postgres.h"
+#include "postgres_ext.h"
 
+#include "access/skey.h"
+#include "access/relscan.h"
+#include "catalog/indexing.h"
+#include "catalog/pg_collation.h"
 #include "catalog/pg_operator.h"
+#include "catalog/pg_statistic.h"
+#include "catalog/pg_type.h"
 #include "nodes/makefuncs.h"
+#include "nodes/pg_list.h"
 #include "optimizer/clauses.h"
 #include "optimizer/cost.h"
 #include "optimizer/pathnode.h"
 #include "optimizer/plancat.h"
+#include "optimizer/var.h"
+#include "utils/array.h"
 #include "utils/fmgroids.h"
 #include "utils/lsyscache.h"
+#include "utils/rel.h"
 #include "utils/selfuncs.h"
-
+#include "utils/syscache.h"
+#include "utils/tqual.h"
 
 /*
  * Data structure for accumulating info about possible range-query
@@ -33,6 +45,7 @@ typedef struct RangeQueryClause
 {
 	struct RangeQueryClause *next;		/* next in linked list */
 	Node	   *var;			/* The common variable of the clauses */
+	AttrNumber	varattno;	/* for finding cross-column statistics */
 	bool		have_lobound;	/* found a low-bound clause yet? */
 	bool		have_hibound;	/* found a high-bound clause yet? */
 	Selectivity lobound;		/* Selectivity of a var > something clause */
@@ -42,6 +55,24 @@ typedef struct RangeQueryClause
 static void addRangeClause(RangeQueryClause **rqlist, Node *clause,
 			   bool varonleft, bool isLTsel, Selectivity s2);
 
+typedef struct CrossColumnClause
+{
+	struct CrossColumnClause *next;
+	Node	   *var;
+	AttrNumber	varattno;
+	OpExpr	   *expr;
+	Selectivity	sel;
+} CrossColumnClause;
+
+static void addXCClause(CrossColumnClause **xclist, OpExpr *clause,
+			   bool varonleft, Selectivity s2);
+
+static bool crosscolumn_selectivity(Oid relId,
+			   CrossColumnClause **xcnext, RangeQueryClause **rqlist,
+			   Selectivity *result_sel);
+
+static Selectivity calculate_xcol_sel(PlannerInfo *root, CrossColumnClause **clauses, int2vector *attnums, HeapTuple statstuple, TupleDesc tupDesc);
+static Selectivity match_xcol_stats(PlannerInfo *root, Oid relId, CrossColumnClause **xclist);
 
 /****************************************************************************
  *		ROUTINES TO COMPUTE SELECTIVITIES
@@ -98,8 +129,13 @@ clauselist_selectivity(PlannerInfo *root,
 {
 	Selectivity s1 = 1.0;
 	RangeQueryClause *rqlist = NULL;
+	CrossColumnClause *xclist = NULL;
+	Oid		relId = InvalidOid;
+	bool		onerel = false;
 	ListCell   *l;
 
+//	elog(NOTICE, "clauselist_selectivity varRelid %d, list length %d", varRelid, list_length(clauses));
+
 	/*
 	 * If there's exactly one clause, then no use in trying to match up pairs,
 	 * so just go directly to clause_selectivity().
@@ -161,6 +197,22 @@ clauselist_selectivity(PlannerInfo *root,
 					 (varonleft = false,
 					  is_pseudo_constant_clause_relids(linitial(expr->args),
 													   rinfo->left_relids)));
+				if (ok)
+				{
+					int	relid;
+					Oid	tmprelId;
+
+					relid = bms_singleton_member(rinfo->clause_relids);
+					tmprelId = root->simple_rte_array[relid]->relid;
+
+					if (!OidIsValid(relId))
+					{
+						onerel = true;
+						relId = tmprelId;
+					}
+					else if (relId != tmprelId)
+						onerel = false;
+				}
 			}
 			else
 			{
@@ -168,6 +220,25 @@ clauselist_selectivity(PlannerInfo *root,
 					(is_pseudo_constant_clause(lsecond(expr->args)) ||
 					 (varonleft = false,
 					  is_pseudo_constant_clause(linitial(expr->args))));
+				if (ok)
+				{
+					Relids	relids;
+					int	relid;
+					Oid	tmprelId;
+
+					relids = pull_varnos(clause);
+					relid = bms_singleton_member(relids);
+					tmprelId = root->simple_rte_array[relid]->relid;
+					bms_free(relids);
+
+					if (!OidIsValid(relId))
+					{
+						onerel = true;
+						relId = tmprelId;
+					}
+					else if (relId != tmprelId)
+						onerel = false;
+				}
 			}
 
 			if (ok)
@@ -187,6 +258,10 @@ clauselist_selectivity(PlannerInfo *root,
 						addRangeClause(&rqlist, clause,
 									   varonleft, false, s2);
 						break;
+					case F_EQSEL:
+						addXCClause(&xclist, expr,
+									   varonleft, s2);
+						break;
 					default:
 						/* Just merge the selectivity in generically */
 						s1 = s1 * s2;
@@ -201,6 +276,34 @@ clauselist_selectivity(PlannerInfo *root,
 	}
 
 	/*
+	 * Scan xclist and rqlist recursively and filter out
+	 * all possible cross-column selectivities.
+	 */
+	if (onerel)
+	{
+		// elog(NOTICE, "Old selectivity: %0.5f", s1);
+		s1 = s1 * match_xcol_stats(root, relId, &xclist);
+		/*crosscolumn_selectivity(relId, &xclist, &rqlist, &s1);*/
+		// elog(NOTICE, "New selectivity: %0.5f", s1);
+	}
+
+	/*
+	 * Free the cross-column clauses
+	 */
+	while (xclist != NULL)
+	{
+		CrossColumnClause *xcnext;
+
+		// elog(NOTICE, "Freeing att %d", xclist->varattno);
+
+		s1 = s1 * xclist->sel;
+
+		xcnext = xclist->next;
+		pfree(xclist);
+		xclist = xcnext;
+	}
+
+	/*
 	 * Now scan the rangequery pair list.
 	 */
 	while (rqlist != NULL)
@@ -278,6 +381,22 @@ clauselist_selectivity(PlannerInfo *root,
 	return s1;
 }
 
+static AttrNumber
+var_get_attno(Node *clause)
+{
+	Var	   *var;
+
+	if (IsA(clause, Var))
+	{
+		var = (Var *)clause;
+//		elog(NOTICE, "var_get_attno varattno %d", var->varattno);
+		return var->varattno;
+	}
+
+//	elog(NOTICE, "var_get_attno default 0");
+	return 0;
+}
+
 /*
  * addRangeClause --- add a new range clause for clauselist_selectivity
  *
@@ -357,6 +476,8 @@ addRangeClause(RangeQueryClause **rqlist, Node *clause,
 	/* No matching var found, so make a new clause-pair data structure */
 	rqelem = (RangeQueryClause *) palloc(sizeof(RangeQueryClause));
 	rqelem->var = var;
+	rqelem->varattno = var_get_attno(var);
+
 	if (is_lobound)
 	{
 		rqelem->have_lobound = true;
@@ -374,6 +495,49 @@ addRangeClause(RangeQueryClause **rqlist, Node *clause,
 }
 
 /*
+ * addXCClause - add a new clause to the list of clauses for cross-column stats inspection
+ *
+ * Clauses are added in varattno order.
+ */
+static void
+addXCClause(CrossColumnClause **xclist, OpExpr *clause,
+					bool varonleft, Selectivity s)
+{
+	CrossColumnClause *xcelem;
+	CrossColumnClause **xcinsertpos;
+	CrossColumnClause *xcnext;
+	Node	   *var;
+	/*Node	   *expr;*/
+
+	if (varonleft)
+	{
+		var = get_leftop((Expr *) clause);
+		/*expr = get_rightop((Expr *) clause);*/
+	}
+	else
+	{
+		var = get_rightop((Expr *) clause);
+		/*expr = get_leftop((Expr *) clause);*/
+	}
+
+	xcelem = (CrossColumnClause *) palloc(sizeof(CrossColumnClause));
+	xcelem->var = var;
+	xcelem->varattno = var_get_attno(var);
+	xcelem->expr = clause;
+	xcelem->sel = s;
+
+	xcinsertpos = xclist;
+	xcnext = *xclist;
+	while (xcnext && xcnext->varattno < xcelem->varattno)
+	{
+		xcinsertpos = &(xcnext->next);
+		xcnext = xcnext->next;
+	}
+	xcelem->next = xcnext;
+	*xcinsertpos = xcelem;
+}
+
+/*
  * bms_is_subset_singleton
  *
  * Same result as bms_is_subset(s, bms_make_singleton(x)),
@@ -498,6 +662,8 @@ clause_selectivity(PlannerInfo *root,
 	{
 		rinfo = (RestrictInfo *) clause;
 
+//		elog(NOTICE, "RestrictInfo, %s", nodeToString(rinfo->clause));
+
 		/*
 		 * If the clause is marked pseudoconstant, then it will be used as a
 		 * gating qual and should not affect selectivity estimates; hence
@@ -563,7 +729,7 @@ clause_selectivity(PlannerInfo *root,
 
 		/*
 		 * We probably shouldn't ever see an uplevel Var here, but if we do,
-		 * return the default selectivity...
+		 * return the default selectivity... (FIXME: wrong comment given code below)
 		 */
 		if (var->varlevelsup == 0 &&
 			(varRelid == 0 || varRelid == (int) var->varno))
@@ -778,3 +944,571 @@ clause_selectivity(PlannerInfo *root,
 
 	return s1;
 }
+
+static bool
+has_xcol_selectivity(Oid relId, int natts, AttrNumber *attnums, Selectivity *result_sel)
+{
+	Relation	rel;
+	Datum		*datums = (Datum *)palloc(natts * sizeof(Datum));
+	ArrayType	*arr_attnums;
+	int		i;
+	int16		typlen;
+	bool		typbyval;
+	char		typalign;
+	ScanKeyData	scanKey[2];
+	SysScanDesc	scan;
+	HeapTuple	tuple;
+	bool		result;
+	Selectivity	sel = 1e-5; /* fixed selectivity for now */
+
+	for (i = 0; i < natts; i++)
+		datums[i] = Int16GetDatum(attnums[i]);
+
+	get_typlenbyvalalign(INT2OID, &typlen, &typbyval, &typalign);
+	arr_attnums = construct_array(datums, natts,
+							INT2OID, typlen, typbyval, typalign);
+
+	rel = heap_open(StatisticRelationId, AccessShareLock);
+
+	ScanKeyInit(&scanKey[0],
+					Anum_pg_statistic_starelid,
+					BTEqualStrategyNumber, F_OIDEQ,
+					ObjectIdGetDatum(relId));
+	ScanKeyInit(&scanKey[1],
+					Anum_pg_statistic_staattnums,
+					BTEqualStrategyNumber, F_ARRAY_EQ,
+					PointerGetDatum(arr_attnums));
+
+	scan = systable_beginscan(rel, StatisticRelidAttnumsInhIndexId, true,
+								SnapshotNow, 2, scanKey);
+
+	tuple = systable_getnext(scan);
+
+	result = HeapTupleIsValid(tuple);
+
+	systable_endscan(scan);
+
+	heap_close(rel, NoLock);
+
+	pfree(datums);
+
+	if (result)
+		*result_sel = sel;
+
+	return result;
+}
+
+static Selectivity
+match_xcol_stats(PlannerInfo *root, Oid relId, CrossColumnClause **xclist)
+{
+	Relation	pgstatistic;
+	Datum		datums[2];
+	ArrayType	*arr_attnums;
+	int16		typlen;
+	bool		typbyval;
+	char		typalign;
+	ScanKeyData	scanKey[2];
+	SysScanDesc	scan;
+	HeapTuple	tuple;
+	TupleDesc	tupDesc;
+	bool		isnull;
+	Datum		sta_attnums_dat;
+	int2vector	*sta_attnum_vec;
+	CrossColumnClause *clauses[STATISTIC_NUM_SLOTS];
+	Selectivity s1, s2;
+	Form_pg_statistic stats;
+
+	s1 = 1.0;
+
+	datums[0] = Int16GetDatum(0);
+	datums[1] = Int16GetDatum(0);
+	get_typlenbyvalalign(INT2OID, &typlen, &typbyval, &typalign);
+	arr_attnums = construct_array(datums, 2,
+							INT2OID, typlen, typbyval, typalign);
+
+
+	pgstatistic = heap_open(StatisticRelationId, AccessShareLock);
+	tupDesc = RelationGetDescr(pgstatistic);
+
+	ScanKeyInit(&scanKey[0],
+					Anum_pg_statistic_starelid,
+					BTEqualStrategyNumber, F_OIDEQ,
+					ObjectIdGetDatum(relId));
+	ScanKeyInit(&scanKey[1],
+					Anum_pg_statistic_staattnums,
+					BTGreaterEqualStrategyNumber, F_INT2VECTORGE,
+					PointerGetDatum(arr_attnums));
+
+	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumsInhIndexId, true,
+								SnapshotNow, 2, scanKey);
+
+	while (HeapTupleIsValid(tuple = systable_getnext(scan))) {
+		CrossColumnClause *xc_tmp;
+		CrossColumnClause **prev_link;
+		int i, cur_attno;
+		Selectivity old_sel = 1.0;
+
+		stats = (Form_pg_statistic) GETSTRUCT(tuple);
+		if (!stats->stavalid)
+			continue;
+
+		sta_attnums_dat = heap_getattr(tuple, Anum_pg_statistic_staattnums, tupDesc, &isnull);
+		Assert(!isnull && sta_attnums_dat);
+		sta_attnum_vec = (int2vector *) DatumGetPointer(sta_attnums_dat);
+
+		/* match up against clauses */
+		xc_tmp = *xclist;
+		for (i = 0; i < sta_attnum_vec->dim1; i++)
+		{
+			cur_attno = sta_attnum_vec->values[i];
+			while (xc_tmp && xc_tmp->varattno < cur_attno)
+				xc_tmp = xc_tmp->next;
+
+			if (!xc_tmp || xc_tmp->varattno > cur_attno)
+				break;
+
+			/* store picked clause */
+			clauses[i] = xc_tmp;
+		}
+		if (i != sta_attnum_vec->dim1) /* No match */
+			continue;
+
+
+
+		s2 = calculate_xcol_sel(root, clauses, sta_attnum_vec, tuple, tupDesc);
+		if (s2 < 0.0)
+			continue;
+
+		/* remove matched clauses from consideration */
+		prev_link = xclist;
+		xc_tmp = *xclist;
+		i = 0;
+		while (xc_tmp && i < sta_attnum_vec->dim1)
+		{
+			if (xc_tmp == clauses[i])
+			{
+				CrossColumnClause *xc_removed;
+				// elog(NOTICE, "Removing clause with att %d from consideration", xc_tmp->varattno);
+				old_sel *= xc_tmp->sel;
+				*prev_link = xc_tmp->next;
+				xc_removed = xc_tmp;
+				xc_tmp = xc_tmp->next;
+				pfree(xc_removed);
+				i++;
+
+			} else {
+				prev_link = &(xc_tmp->next);
+				xc_tmp = xc_tmp->next;
+			}
+		}
+		// elog(NOTICE, "New selectivity %0.5f old sel %0.5f", s2, old_sel);
+		/* Merge in selectivity */
+		s1 = s1*s2;
+	}
+	systable_endscan(scan);
+
+	heap_close(pgstatistic, AccessShareLock);
+
+	return s1;
+}
+
+/* Calculates selectivity from cross column statistics.
+ * Returns a negative number if not possible to calculate. */
+static Selectivity
+calculate_xcol_sel(PlannerInfo *root, CrossColumnClause **clauses, int2vector *attnums, HeapTuple statstuple, TupleDesc tupDesc)
+{
+	int i;
+	/* elog(NOTICE, "Calculating stats for %d clauses", attnums->dim1);
+	for (i = 0; i < attnums->dim1; i++)
+	{
+		elog(NOTICE, "Attribute number: %d", clauses[i]->varattno);
+	}*/
+	bool		isnull;
+	Datum		values_dat;
+	ArrayType	*statarray;
+	Oid			arrayelemtype;
+	HeapTuple	typeTuple;
+	Form_pg_type typeForm;
+	Datum		*values;
+	int			nvalues;
+	int			j;
+	CrossColumnClause *clause;
+	Form_pg_statistic stats;
+	int			dimindices[STATISTIC_NUM_SLOTS];
+	int			dimstrides[STATISTIC_NUM_SLOTS];
+	int			mcv_index;
+	Selectivity		s1 = 1.0;
+
+	stats = (Form_pg_statistic) GETSTRUCT(statstuple);
+
+	for (i = 0; i < attnums->dim1; i++)
+	{
+		VariableStatData vardata;
+		Node		*other;
+		bool		varonleft;
+		Datum 		constval;
+		bool		result;
+		FmgrInfo	eqproc;
+
+		clause = clauses[i];
+
+		/* FIXME: refactor multi-col stats storage to store operators per col
+		 * so we can check that the correct op is used
+		opproc = DatumGetObjectId(heap_getattr(statstuple, Anum_pg_statistic_staop1 + i,
+				  tupDesc, &isnull));
+		Assert(opproc == clause->expr->opno); */
+		values_dat = heap_getattr(statstuple, Anum_pg_statistic_stavalues1 + i,
+								  tupDesc, &isnull);
+		Assert(!isnull);
+
+		statarray = DatumGetArrayTypeP(values_dat);
+
+		arrayelemtype = ARR_ELEMTYPE(statarray);
+		typeTuple = SearchSysCache1(TYPEOID, ObjectIdGetDatum(arrayelemtype));
+		if (!HeapTupleIsValid(typeTuple))
+			elog(ERROR, "cache lookup failed for type %u", arrayelemtype);
+
+		typeForm = (Form_pg_type) GETSTRUCT(typeTuple);
+		deconstruct_array(statarray,
+						  arrayelemtype,
+						  typeForm->typlen,
+						  typeForm->typbyval,
+						  typeForm->typalign,
+						  &values, NULL, &nvalues);
+		ReleaseSysCache(typeTuple);
+
+		dimstrides[i] = 1;
+		for (j = i-1; j >= 0; j--)
+		{
+			dimstrides[j] *= (nvalues + 2);
+		}
+
+		get_restriction_variable(root, clause->expr->args, 0 /* FIXME: pass this in */,
+							&vardata, &other, &varonleft);
+		constval = ((Const *) other)->constvalue;
+
+		/* Null is stored in the first item of a dimension */
+		if (((Const *)other)->constisnull)
+		{
+			dimindices[i] = 0;
+			ReleaseVariableStats(vardata);
+			continue;
+		}
+
+		/* TODO: use binary search when possible */
+		for (j = 0; j < nvalues; j++)
+		{
+			fmgr_info(get_opcode(clause->expr->opno), &eqproc);
+			// elog(NOTICE, "Comparing %d to %d using %d", values[j], constval, clause->expr->opno);
+			result = DatumGetBool(FunctionCall2Coll(&eqproc,
+									   DEFAULT_COLLATION_OID,
+									   values[j],
+									   constval));
+			if (result) { /* Found matching value */
+				dimindices[i] = j+2;
+				break;
+			}
+		}
+
+		if (j == nvalues) /* Nothing matching was found in MCV's */
+		{
+			double ndistinct;
+			bool isdefault;
+
+			// elog(NOTICE, "Value for dimension %d not found, constval %d", i, constval);
+			dimindices[i] = 1;
+
+			/* We presume uniform distribution of values not present in MCV.
+			 * Predivide selectivity with ndistinct for this column. */
+			ndistinct = get_variable_numdistinct(&vardata, &isdefault);
+			ndistinct -= nvalues;
+			// elog(NOTICE, "Predividing selectivity with %f", ndistinct);
+			if (ndistinct > 1.0)
+				s1 = s1 / ndistinct;
+		}
+
+		/*
+		 * Free statarray if it's a detoasted copy.
+		 */
+		if ((Pointer) statarray != DatumGetPointer(values_dat))
+			pfree(statarray);
+
+		ReleaseVariableStats(vardata);
+	}
+
+	mcv_index = 0;
+	for (i = 0; i < attnums->dim1; i++)
+	{
+		mcv_index += dimindices[i]*dimstrides[i];
+		// elog(NOTICE, "MCV dimension %d index %d", i, dimindices[i]);
+	}
+	// elog(NOTICE, "MCV position %d", mcv_index);
+	do {
+		Datum		numbers_dat;
+		int			narrayelem;
+
+		numbers_dat = heap_getattr(statstuple, Anum_pg_statistic_stanumbers1,
+								  tupDesc, &isnull);
+		Assert(!isnull);
+
+		statarray = DatumGetArrayTypeP(numbers_dat);
+
+		/*
+		 * We expect the array to be a 1-D float4 array; verify that. We don't
+		 * need to use deconstruct_array() since the array data is just going
+		 * to look like a C array of float4 values.
+		 */
+		narrayelem = ARR_DIMS(statarray)[0];
+		if (ARR_NDIM(statarray) != 1 || narrayelem <= 0 ||
+			ARR_HASNULL(statarray) ||
+			ARR_ELEMTYPE(statarray) != FLOAT4OID)
+			elog(ERROR, "stanumbers is not a 1-D float4 array");
+		if (narrayelem <= mcv_index)
+			elog(ERROR, "stanumbers is too short");
+		s1 = s1 * ((float4 *) ARR_DATA_PTR(statarray))[mcv_index];
+
+		/*
+		 * Free statarray if it's a detoasted copy.
+		 */
+		if ((Pointer) statarray != DatumGetPointer(numbers_dat))
+			pfree(statarray);
+
+	} while(0);
+
+	//elog(NOTICE, "Returning selectivity %0.7f", s1);
+	return s1;
+}
+
+typedef struct {
+	CrossColumnClause	*xc;
+	RangeQueryClause	*rq;
+} reclist;
+
+typedef struct {
+	int	len;
+	reclist	*rclist;
+	AttrNumber *attnums;
+} reclist2;
+
+
+/* add rclist to our list, so the ordered attnums arrays are unique */
+static void
+add_reclist(int len, reclist *rclist, List **results)
+{
+	ListCell   *lc;
+	int		i, j;
+	reclist2	*rclist2;
+	AttrNumber	*attnums = (AttrNumber *) palloc(len * sizeof(AttrNumber));
+
+	/* collect the ordered varattnos from the Vars */
+	for (i = 0; i < len; i++)
+	{
+		if (rclist[i].xc)
+			attnums[i] = rclist[i].xc->varattno;
+		else
+			attnums[i] = rclist[i].rq->varattno;
+	}
+	/* FIXME: is this supposed to be a bubblesort? Maybe do an insertion sort? */
+	for (i = 0; i < len - 1; i++)
+		for (j = i + 1; j < len; j++)
+		{
+			AttrNumber tmp = attnums[i];
+			attnums[i] = attnums[j];
+			attnums[j] = tmp;
+		}
+
+	/* match this ordered attnum list against the current list of attnum arrays */
+	foreach(lc, *results)
+	{
+		reclist2   *rc2 = (reclist2 *) lfirst(lc);
+
+		if (len != rc2->len)
+			continue;
+
+		for (i = 0; i < len; i++)
+			if (attnums[i] != rc2->attnums[i])
+				break;
+		if (i < len)
+			continue;
+
+		/* found */
+		return;
+	}
+
+	/* not found, add it to the list */
+	rclist2 = (reclist2 *) palloc(sizeof(reclist2));
+	rclist2->len = len;
+	rclist2->rclist = (reclist *) palloc(len * sizeof(reclist));
+	for (i = 0; i < len; i++)
+	{
+		rclist2->rclist[i].xc = rclist[i].xc;
+		rclist2->rclist[i].rq = rclist[i].rq;
+	}
+	rclist2->attnums = attnums;
+
+	*results = lappend(*results, rclist2);
+}
+
+static int
+compare_reclist2(reclist2 *a, reclist2 *b)
+{
+	int	i;
+
+	if (a->len < b->len)
+		return -1;
+	else if (a->len > b->len)
+		return 1;
+
+	for (i = 0; i < a->len; i++)
+	{
+		if (a->attnums[i] < b->attnums[i])
+			return -1;
+		else if (a->attnums[i] > b->attnums[i])
+			return 1;
+	}
+
+	return 0;
+}
+
+static bool
+add_reclist2(int *len, reclist2 **p_reclist2, reclist2 *rclist2)
+{
+	int	curr_len = *len;
+	int	i, j;
+
+	if (curr_len == 0)
+	{
+		p_reclist2[i] = rclist2;
+		curr_len++;
+		*len = curr_len;
+		return true;
+	}
+
+	for (i = 0; i < curr_len; i++)
+	{
+		if (compare_reclist2(rclist2, p_reclist2[i]) > 0)
+		{
+			for (j = curr_len; j > i; j--)
+				p_reclist2[j] = p_reclist2[j - 1];
+			p_reclist2[i] = rclist2;
+			curr_len++;
+			*len = curr_len;
+			return true;
+		}
+	}
+
+	return false;
+}
+
+static void
+collect_xcol_lists(int curr_depth, CrossColumnClause *xclist, RangeQueryClause *rqlist, reclist *rclist, List **results)
+{
+	CrossColumnClause	*xc_tmp;
+	RangeQueryClause	*rq_tmp;
+
+	for (xc_tmp = xclist; xc_tmp; xc_tmp = xc_tmp->next)
+	{
+		if (xc_tmp->varattno == 0)
+			continue;
+
+		rclist[curr_depth].xc = xc_tmp;
+		collect_xcol_lists(curr_depth + 1, xc_tmp->next, rqlist, rclist, results);
+		add_reclist(curr_depth + 1, rclist, results);
+		rclist[curr_depth].xc = NULL;
+	}
+
+	for (rq_tmp = rqlist; rq_tmp; rq_tmp = rq_tmp->next)
+	{
+		if (rq_tmp->varattno == 0)
+			continue;
+
+		rclist[curr_depth].rq = rq_tmp;
+		collect_xcol_lists(curr_depth + 1, (xclist ? xclist->next : xclist), rq_tmp->next, rclist, results);
+		add_reclist(curr_depth + 1, rclist, results);
+		rclist[curr_depth].rq = NULL;
+	}
+}
+
+static bool
+crosscolumn_selectivity(Oid relId, CrossColumnClause **xclist, RangeQueryClause **rqlist, Selectivity *result_sel)
+{
+	CrossColumnClause *xc;
+	RangeQueryClause *rq;
+	List	   *resultlist = NIL;
+	ListCell   *lc;
+	reclist	   *rclist;
+	reclist2   **p_rclist2;
+	int		max_len, i;
+	Selectivity	sel = 1.0;
+	bool		found_xc_sel = false;
+
+	max_len = 0;
+	for (rq = *rqlist; rq; max_len++, rq = rq->next)
+		;
+	for (xc = *xclist; xc; max_len++, xc = xc->next)
+		;
+
+//	elog(NOTICE, "crosscolumn_selectivity max length of array %d", max_len);
+
+	rclist = (reclist *) palloc(max_len * sizeof(reclist));
+	for (i = 0; i < max_len; i++)
+	{
+		rclist[i].xc = NULL;
+		rclist[i].rq = NULL;
+	}
+
+	collect_xcol_lists(0, *xclist, *rqlist, rclist, &resultlist);
+
+	pfree(rclist);
+
+	max_len = list_length(resultlist);
+//	elog(NOTICE, "crosscolumn_selectivity list length of arrays %d", max_len);
+	p_rclist2 = (reclist2 **) palloc(max_len * sizeof(reclist2 *));
+
+	max_len = 0;
+	foreach (lc, resultlist)
+	{
+		reclist2 *rclist2 = (reclist2 *) lfirst(lc);
+
+		if (!add_reclist2(&max_len, p_rclist2, rclist2))
+		{
+			pfree(rclist2->rclist);
+			pfree(rclist2->attnums);
+			pfree(rclist2);
+		}
+	}
+//	elog(NOTICE, "crosscolumn_selectivity length of ordered/unique array of previous list %d", max_len);
+
+	list_free(resultlist);
+
+	for (i = 0; i < max_len; i++)
+	{
+		if (p_rclist2[i] == NULL)
+			continue;
+
+		if (has_xcol_selectivity(relId, p_rclist2[i]->len, p_rclist2[i]->attnums, &sel))
+		{
+			int	j;
+
+			/* remove the xclist and rqlist members found in p_rclist2[i] */
+			for (j = 0; j < p_rclist2[i]->len; j++)
+			{
+				/* TODO ... */
+			}
+
+			/* also, remove later elements in p_rclist2 that has any of the removed elements */
+			/* TODO ... */
+
+//			elog(NOTICE, "crosscolumn_selectivity found xc selectivity %lf", sel);
+			found_xc_sel = true;
+			*result_sel *= sel;
+		}
+
+		pfree(p_rclist2[i]->rclist);
+		pfree(p_rclist2[i]->attnums);
+		pfree(p_rclist2[i]);
+	}
+	pfree(p_rclist2);
+
+	return found_xc_sel;
+}
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 9aea2cd..7e4f352 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -214,7 +214,7 @@ static void processCASbits(int cas_bits, int location, const char *constrType,
 		DropGroupStmt DropOpClassStmt DropOpFamilyStmt DropPLangStmt DropStmt
 		DropAssertStmt DropTrigStmt DropRuleStmt DropCastStmt DropRoleStmt
 		DropUserStmt DropdbStmt DropTableSpaceStmt DropFdwStmt
-		DropForeignServerStmt DropUserMappingStmt ExplainStmt FetchStmt
+		DropForeignServerStmt DropUserMappingStmt ExplainStmt ExtraStatStmt FetchStmt
 		GrantStmt GrantRoleStmt IndexStmt InsertStmt ListenStmt LoadStmt
 		LockStmt NotifyStmt ExplainableStmt PreparableStmt
 		CreateFunctionStmt AlterFunctionStmt ReindexStmt RemoveAggrStmt
@@ -246,7 +246,7 @@ static void processCASbits(int cas_bits, int location, const char *constrType,
 				transaction_mode_item
 				create_extension_opt_item alter_extension_opt_item
 
-%type <ival>	opt_lock lock_type cast_context
+%type <ival>	opt_lock lock_type cast_context opt_stattarget
 %type <ival>	vacuum_option_list vacuum_option_elem
 %type <boolean>	opt_force opt_or_replace
 				opt_grant_grant_option opt_grant_admin_option
@@ -325,6 +325,8 @@ static void processCASbits(int cas_bits, int location, const char *constrType,
 %type <list>	opt_fdw_options fdw_options
 %type <defelt>	fdw_option
 
+%type <list>	cc_column_list
+
 %type <range>	OptTempTableName
 %type <into>	into_clause create_as_target
 
@@ -755,6 +757,7 @@ stmt :
 			| DropdbStmt
 			| ExecuteStmt
 			| ExplainStmt
+			| ExtraStatStmt
 			| FetchStmt
 			| GrantStmt
 			| GrantRoleStmt
@@ -1199,6 +1202,74 @@ schema_stmt:
 
 /*****************************************************************************
  *
+ * Add / drop extra statistics
+ *
+ *****************************************************************************/
+
+ExtraStatStmt:
+			CREATE CROSS COLUMN STATISTICS ON TABLE qualified_name '(' cc_column_list ')' opt_stattarget
+				{
+					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+
+					n->relkind = 'r';
+					n->create = true;
+					n->relation = $7;
+					n->columns = $9;
+					n->statistics_target = $11;
+					$$ = (Node *)n;
+				}
+			| DROP CROSS COLUMN STATISTICS ON TABLE qualified_name '(' cc_column_list ')'
+				{
+					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+
+					n->relkind = 'r';
+					n->create = false;
+					n->relation = $7;
+					n->columns = $9;
+					$$ = (Node *)n;
+				}
+			| CREATE CROSS COLUMN STATISTICS ON INDEX qualified_name opt_stattarget
+				{
+					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+
+					n->relkind = 'i';
+					n->create = true;
+					n->relation = $7;
+					n->columns = NIL;
+					n->statistics_target = $8;
+					$$ = (Node *)n;
+				}
+			| DROP CROSS COLUMN STATISTICS ON INDEX qualified_name
+				{
+					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+
+					n->relkind = 'i';
+					n->create = false;
+					n->relation = $7;
+					n->columns = NIL;
+					$$ = (Node *)n;
+				}
+		;
+
+cc_column_list:
+			columnref
+				{
+					$$ = list_make1($1);
+				}
+			| cc_column_list ',' columnref
+				{
+					$$ = lappend($1, $3);
+				}
+		;
+
+opt_stattarget:
+			WITH '(' Iconst ')'			{ $$ = $3; }
+			| /* EMPTY */				{ $$ = -1; }
+		;
+
+
+/*****************************************************************************
+ *
  * Set PG internal variable
  *	  SET name TO 'var_value'
  * Include SQL92 syntax (thomas 1997-10-22):
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
index 43f5634..2378435 100644
--- a/src/backend/parser/parse_utilcmd.c
+++ b/src/backend/parser/parse_utilcmd.c
@@ -2754,3 +2754,96 @@ setSchemaName(char *context_schema, char **stmt_schema_name)
 						"different from the one being created (%s)",
 						*stmt_schema_name, context_schema)));
 }
+
+/*
+ * transformExtraStatistics
+ *             Transform the column list or the expression into a form
+ *             usable by the executor.
+ */
+ExtraStatStmt *
+transformExtraStatistics(ExtraStatStmt *stmt, const char *queryString)
+{
+	ParseState	   *pstate;
+	RangeTblEntry	   *rte;
+	ExtraStatStmt	   *newstmt;
+	List		   *columns = NIL;
+	ListCell	   *cell;
+	Oid			relId;
+	HeapTuple		tuple;
+	HeapTuple		attuple;
+	Form_pg_class		classptr;
+	Form_pg_index		indexptr;
+	Form_pg_attribute	attptr;
+	AttrNumber		i;
+
+	switch (stmt->relkind)
+	{
+		case 'r':
+			pstate = make_parsestate(NULL);
+			pstate->p_sourcetext = queryString;
+
+			rte = addRangeTableEntry(pstate, stmt->relation, NULL, false, true);
+			addRTEtoQuery(pstate, rte, true, true, true);
+
+			foreach(cell, stmt->columns)
+			{
+				Node *col = lfirst(cell);
+
+				columns = lappend(columns, transformExpr(pstate, col));
+			}
+
+			break;
+
+		case 'i':
+			relId = RangeVarGetRelid(stmt->relation, ShareLock, false);
+
+			tuple = SearchSysCache1(RELOID, relId);
+			classptr = (Form_pg_class) GETSTRUCT(tuple);
+
+			if (classptr->relkind != 'i')
+				elog(ERROR, "not an index");
+
+			ReleaseSysCache(tuple);
+
+			tuple = SearchSysCache1(INDEXRELID, relId);
+			indexptr = (Form_pg_index) GETSTRUCT(tuple);
+
+			if (indexptr->indnatts < 2)
+			{
+				ReleaseSysCache(tuple);
+
+				elog(ERROR, "cross column statistics are only usable on multi-column indexes");
+			}
+
+			for (i = 1; i <= indexptr->indnatts; i++)
+			{
+				attuple = SearchSysCache2(ATTNUM, relId, i);
+				if (!HeapTupleIsValid(attuple))
+					elog(ERROR, "pg_attribute row not found for index");
+
+				attptr = (Form_pg_attribute) GETSTRUCT(attuple);
+
+				columns = lappend(columns, makeVar(0, i,
+										attptr->atttypid,
+										attptr->atttypmod,
+										InvalidOid, 0));
+
+				ReleaseSysCache(attuple);
+			}
+
+			ReleaseSysCache(tuple);
+			break;
+
+		default:
+			elog(ERROR, "invalid relkind");
+	}
+
+	newstmt = makeNode(ExtraStatStmt);
+	newstmt->relkind = stmt->relkind;
+	newstmt->create = stmt->create;
+	newstmt->relation = copyObject(stmt->relation);
+	newstmt->columns = columns;
+	newstmt->statistics_target = stmt->statistics_target;
+
+	return newstmt;
+}
diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index 5b81c0b..6506142 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -230,6 +230,7 @@ check_xact_readonly(Node *parsetree)
 		case T_AlterTableSpaceOptionsStmt:
 		case T_CreateForeignTableStmt:
 		case T_SecLabelStmt:
+		case T_ExtraStatStmt:
 			PreventCommandIfReadOnly(CreateCommandTag(parsetree));
 			break;
 		default:
@@ -574,6 +575,14 @@ standard_ProcessUtility(Node *parsetree,
 			}
 			break;
 
+		case T_ExtraStatStmt:
+			{
+				ExtraStatStmt *newstmt = transformExtraStatistics((ExtraStatStmt *)parsetree, queryString);
+
+				ExtraStatistics(newstmt);
+			}
+			break;
+
 		case T_CreateTableSpaceStmt:
 			PreventTransactionChain(isTopLevel, "CREATE TABLESPACE");
 			CreateTableSpace((CreateTableSpaceStmt *) parsetree);
@@ -1638,6 +1647,17 @@ CreateCommandTag(Node *parsetree)
 			tag = "CREATE FOREIGN TABLE";
 			break;
 
+		case T_ExtraStatStmt:
+			{
+				ExtraStatStmt *stmt = (ExtraStatStmt *)parsetree;
+
+				if (stmt->create)
+					tag = "CREATE CROSS COLUMN STATISTICS";
+				else
+					tag = "DROP CROSS COLUMN STATISTICS";
+			}
+			break;
+
 		case T_DropStmt:
 			switch (((DropStmt *) parsetree)->removeType)
 			{
